/**
 * Card details required for 3DS
 */
export class CardData {
    /** 
     * Card Brand 
     */
    cardType!: CardTypes;
    /**
     * PAN
     */
    cardNumber!: string;
    /**
     * Expiration Year
     */
    expirationYear!: number;
    /**
     * Expiration month (1..12)
     */
    expirationMonth!: number;
    /**
     * Name on card
     */
    cardHolderName!: string;
    /** 
     * Cardholder email address 
     * */
    customerEmail!: string;
    /** 
     * Cardholder phone number (incl. country code, no '+' sign, digits only) 
     * */
     customerPhone!: string;
}

/**
 * Card types
 */
export type CardTypes = 
    "AMEX" |
    "BC" |
    "CartaSi" |
    "Dankort" |
    "Delta" |
    "DinersClub" |
    "Discover" |
    "Electron" |
    "Elo" |
    "enRoute" |
    "Hipercard" |
    "JCB" |
    "Maestro" |
    "MasterCard" |
    "MC_Alaska" |
    "MC_Canada" |
    "Switch" |
    "Troy" |
    "UATP" |
    "UnionPay" |
    "Visa";
