const path = require('path');
const TerserPlugin = require('terser-webpack-plugin');

module.exports = {
  entry: ['./src/threeDs.ts'],
  module: {
    rules: [
      {
        test: /\.ts?$/,
        use: 'ts-loader',
        exclude: /node_modules/,
      },
      {
        test: /\.(png|jpg)/i,
        type: 'asset/inline',
      },
    ],
  },
  optimization: {
    minimize: true,
    removeAvailableModules: false,
    removeEmptyChunks: false,
    minimizer: [
      new TerserPlugin({
        extractComments: false,
        terserOptions: {
          keep_classnames: true,
        },
      }),
    ],
  },
  resolve: {
    extensions: ['.tsx', '.ts', '.js'],
  },
  output: {
    filename: 'threeDs.js',
    path: path.resolve(__dirname, 'dist'),
    clean: true,
    library: "threeDs",
    libraryTarget: 'umd',
    umdNamedDefine: true,
  },
  devtool: 'source-map'
  // commented out as generated a corrupted merged file
  // plugins: [
  //   new TypescriptDeclarationPlugin({
  //     // Options for TypescriptDeclarationPlugin (see below)
  //     // out: "./ewallet.d.ts"
  //   })
  // ]
};